// Made with Blockbench 4.1.4
// Exported for Minecraft version 1.17 with Mojang mappings
// Paste this class into your mod and generate all required imports

public class Modelice_golem<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(
			new ResourceLocation("modid", "ice_golem "), "main");
	private final ModelPart head;
	private final ModelPart body;
	private final ModelPart right_leg;
	private final ModelPart left_leg;
	private final ModelPart left_arm;
	private final ModelPart right_arm;

	public Modelice_golem(ModelPart root) {
		this.head = root.getChild("head");
		this.body = root.getChild("body");
		this.right_leg = root.getChild("right_leg");
		this.left_leg = root.getChild("left_leg");
		this.left_arm = root.getChild("left_arm");
		this.right_arm = root.getChild("right_arm");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		PartDefinition head = partdefinition.addOrReplaceChild("head", CubeListBuilder.create().texOffs(40, 16)
				.addBox(-4.0F, -23.0F, -3.0F, 7.0F, 5.0F, 7.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 22.0F, -6.0F));

		PartDefinition cube_r1 = head.addOrReplaceChild("cube_r1",
				CubeListBuilder.create().texOffs(39, 0).addBox(-3.45F, -1.0F, -6.0F, 7.0F, 2.0F, 7.0F,
						new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-0.55F, -17.0F, 3.0F, 0.2182F, 0.0F, 0.0F));

		PartDefinition body = partdefinition.addOrReplaceChild("body",
				CubeListBuilder.create().texOffs(0, 0)
						.addBox(-8.0F, -20.0F, -4.0F, 15.0F, 7.0F, 9.0F, new CubeDeformation(0.0F)).texOffs(0, 27)
						.addBox(-5.0F, -13.0F, -3.0F, 9.0F, 2.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(0, 16)
						.addBox(-6.0F, -11.0F, -4.0F, 11.0F, 2.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 24.0F, 0.0F));

		PartDefinition spike = body.addOrReplaceChild("spike",
				CubeListBuilder.create().texOffs(39, 55)
						.addBox(2.0F, -25.0F, 0.0F, 5.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(48, 9)
						.addBox(3.0F, -28.0F, 1.0F, 3.0F, 3.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(0, 16)
						.addBox(4.0F, -31.0F, 2.0F, 1.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-2.0F, 0.0F, 0.0F, 0.0435F, -0.0038F, 0.0872F));

		PartDefinition spike2 = body.addOrReplaceChild("spike2",
				CubeListBuilder.create().texOffs(24, 45)
						.addBox(2.0F, -25.0F, 0.0F, 5.0F, 8.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(42, 28)
						.addBox(3.0F, -28.0F, 1.0F, 3.0F, 3.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(3, 3)
						.addBox(4.0F, -31.0F, 2.0F, 1.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-4.0F, 0.0F, 0.0F, 0.0873F, -0.2182F, -0.0873F));

		PartDefinition spike3 = body.addOrReplaceChild("spike3",
				CubeListBuilder.create().texOffs(44, 40)
						.addBox(2.0F, -25.0F, 0.0F, 5.0F, 10.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(31, 16)
						.addBox(3.0F, -28.0F, 1.0F, 3.0F, 3.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(0, 0)
						.addBox(4.0F, -31.0F, 2.0F, 1.0F, 3.0F, 1.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-2.0F, 0.0F, -3.0F, -0.1745F, 0.0F, 0.0F));

		PartDefinition right_leg = partdefinition.addOrReplaceChild("right_leg",
				CubeListBuilder.create().texOffs(0, 61)
						.addBox(2.0F, -9.0F, -1.0F, 3.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(64, 37)
						.addBox(1.0F, -7.0F, -2.0F, 5.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(0, 52)
						.addBox(1.0F, -2.0F, -3.0F, 5.0F, 2.0F, 7.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-7.0F, 24.0F, 0.0F));

		PartDefinition left_leg = partdefinition.addOrReplaceChild("left_leg",
				CubeListBuilder.create().texOffs(60, 0)
						.addBox(-5.0F, -9.0F, -1.0F, 3.0F, 2.0F, 3.0F, new CubeDeformation(0.0F)).texOffs(61, 9)
						.addBox(-6.0F, -7.0F, -2.0F, 5.0F, 5.0F, 5.0F, new CubeDeformation(0.0F)).texOffs(49, 28)
						.addBox(-6.0F, -2.0F, -3.0F, 5.0F, 2.0F, 7.0F, new CubeDeformation(0.0F)),
				PartPose.offset(6.0F, 24.0F, 0.0F));

		PartDefinition left_arm = partdefinition.addOrReplaceChild("left_arm",
				CubeListBuilder.create().texOffs(0, 36)
						.addBox(-1.0F, -4.0F, -3.0F, 5.0F, 9.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(59, 50)
						.addBox(0.0F, 5.0F, -2.0F, 3.0F, 9.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offset(8.0F, 7.0F, 0.0F));

		PartDefinition right_arm = partdefinition.addOrReplaceChild("right_arm",
				CubeListBuilder.create().texOffs(25, 29)
						.addBox(-5.0F, -5.0F, -3.0F, 5.0F, 9.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(19, 58)
						.addBox(-4.0F, 4.0F, -2.0F, 3.0F, 9.0F, 5.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-7.0F, 8.0F, 0.0F));

		return LayerDefinition.create(meshdefinition, 128, 128);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer buffer, int packedLight, int packedOverlay,
			float red, float green, float blue, float alpha) {
		head.render(poseStack, buffer, packedLight, packedOverlay);
		body.render(poseStack, buffer, packedLight, packedOverlay);
		right_leg.render(poseStack, buffer, packedLight, packedOverlay);
		left_leg.render(poseStack, buffer, packedLight, packedOverlay);
		left_arm.render(poseStack, buffer, packedLight, packedOverlay);
		right_arm.render(poseStack, buffer, packedLight, packedOverlay);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw,
			float headPitch) {
		this.head.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.head.xRot = headPitch / (180F / (float) Math.PI);
		this.left_leg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.right_arm.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.right_leg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.left_arm.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
	}
}