
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.golemsmod.init;

import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.entity.EntityAttributeCreationEvent;
import net.minecraftforge.event.RegistryEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;

import net.mcreator.golemsmod.entity.StonegolemEntity;
import net.mcreator.golemsmod.entity.LavagolemEntity;
import net.mcreator.golemsmod.entity.IcegolemEntity;
import net.mcreator.golemsmod.entity.HmerEntity;

import java.util.List;
import java.util.ArrayList;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class GolemsModModEntities {
	private static final List<EntityType<?>> REGISTRY = new ArrayList<>();
	public static final EntityType<IcegolemEntity> ICEGOLEM = register("icegolem",
			EntityType.Builder.<IcegolemEntity>of(IcegolemEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64)
					.setUpdateInterval(3).setCustomClientFactory(IcegolemEntity::new).sized(0.6f, 1.8f));
	public static final EntityType<LavagolemEntity> LAVAGOLEM = register("lavagolem",
			EntityType.Builder.<LavagolemEntity>of(LavagolemEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true)
					.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(LavagolemEntity::new).fireImmune().sized(0.6f, 1.8f));
	public static final EntityType<StonegolemEntity> STONEGOLEM = register("stonegolem",
			EntityType.Builder.<StonegolemEntity>of(StonegolemEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true)
					.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(StonegolemEntity::new).sized(0.6f, 1.8f));
	public static final EntityType<HmerEntity> HMER = register("entitybullethmer",
			EntityType.Builder.<HmerEntity>of(HmerEntity::new, MobCategory.MISC).setCustomClientFactory(HmerEntity::new)
					.setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));

	private static <T extends Entity> EntityType<T> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		EntityType<T> entityType = (EntityType<T>) entityTypeBuilder.build(registryname).setRegistryName(registryname);
		REGISTRY.add(entityType);
		return entityType;
	}

	@SubscribeEvent
	public static void registerEntities(RegistryEvent.Register<EntityType<?>> event) {
		event.getRegistry().registerAll(REGISTRY.toArray(new EntityType[0]));
	}

	@SubscribeEvent
	public static void init(FMLCommonSetupEvent event) {
		event.enqueueWork(() -> {
			IcegolemEntity.init();
			LavagolemEntity.init();
			StonegolemEntity.init();
		});
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(ICEGOLEM, IcegolemEntity.createAttributes().build());
		event.put(LAVAGOLEM, LavagolemEntity.createAttributes().build());
		event.put(STONEGOLEM, StonegolemEntity.createAttributes().build());
	}
}
