package net.mcreator.golemsmod.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.util.Mth;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.1.4
// Exported for Minecraft version 1.17 with Mojang mappings
// Paste this class into your mod and generate all required imports
public class Modelcustom_model<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("golems_mod", "modelcustom_model"), "main");
	public final ModelPart head;
	public final ModelPart body;
	public final ModelPart left_hand;
	public final ModelPart right_hand;
	public final ModelPart left_leg;
	public final ModelPart right_leg;

	public Modelcustom_model(ModelPart root) {
		this.head = root.getChild("head");
		this.body = root.getChild("body");
		this.left_hand = root.getChild("left_hand");
		this.right_hand = root.getChild("right_hand");
		this.left_leg = root.getChild("left_leg");
		this.right_leg = root.getChild("right_leg");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition head = partdefinition.addOrReplaceChild("head",
				CubeListBuilder.create().texOffs(59, 12).addBox(-4.375F, -7.0F, -9.0F, 9.0F, 7.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-0.625F, -4.0F, -4.0F));
		PartDefinition jaw = head.addOrReplaceChild("jaw",
				CubeListBuilder.create().texOffs(31, 21).addBox(-5.0F, -1.0F, -9.0F, 9.0F, 2.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.625F, 1.0F, 0.0F, 0.1745F, 0.0F, 0.0F));
		PartDefinition body = partdefinition.addOrReplaceChild("body",
				CubeListBuilder.create().texOffs(0, 0).addBox(-11.0F, -30.0F, -6.0F, 21.0F, 8.0F, 13.0F, new CubeDeformation(0.0F)).texOffs(55, 0)
						.addBox(-7.0F, -19.0F, -0.975F, 13.0F, 3.0F, 7.0F, new CubeDeformation(0.0F)).texOffs(0, 54)
						.addBox(-9.0F, -16.0F, -2.175F, 17.0F, 3.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 24.0F, 0.0F));
		PartDefinition cube_r1 = body.addOrReplaceChild("cube_r1",
				CubeListBuilder.create().texOffs(52, 54).addBox(-7.0F, -6.0F, -3.0F, 13.0F, 9.0F, 7.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -20.0F, 1.225F, 0.3927F, 0.0F, 0.0F));
		PartDefinition left_hand = partdefinition.addOrReplaceChild("left_hand",
				CubeListBuilder.create().texOffs(31, 32).addBox(0.0F, -4.0F, -5.0F, 10.0F, 11.0F, 11.0F, new CubeDeformation(0.0F)).texOffs(30, 66)
						.addBox(2.0F, 7.0F, -4.0F, 6.0F, 11.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(10.0F, -3.0F, 0.0F, 0.1745F, 0.0F, 0.0F));
		PartDefinition cube_r2 = left_hand.addOrReplaceChild("cube_r2",
				CubeListBuilder.create().texOffs(73, 28).addBox(11.0F, -10.0F, -6.575F, 8.0F, 10.0F, 11.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-10.0F, 27.0F, 0.0F, -0.1745F, 0.0F, 0.0F));
		PartDefinition right_hand = partdefinition.addOrReplaceChild("right_hand",
				CubeListBuilder.create().texOffs(0, 21).addBox(-10.0F, -4.0F, -5.0F, 10.0F, 11.0F, 11.0F, new CubeDeformation(0.0F)).texOffs(0, 66)
						.addBox(-8.0F, 7.0F, -4.0F, 6.0F, 11.0F, 9.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-10.0F, -3.0F, 0.0F, 0.1745F, 0.0F, 0.0F));
		PartDefinition cube_r3 = right_hand.addOrReplaceChild("cube_r3",
				CubeListBuilder.create().texOffs(32, 32).addBox(-19.0F, -10.0F, -6.575F, 8.0F, 10.0F, 11.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(10.0F, 27.0F, 0.0F, -0.1745F, 0.0F, 0.0F));
		PartDefinition left_leg = partdefinition.addOrReplaceChild(
				"left_leg", CubeListBuilder.create().texOffs(62, 28).addBox(-2.65F, 1.0F, -3.0F, 5.0F, 4.0F, 5.0F, new CubeDeformation(0.0F))
						.texOffs(85, 63).addBox(-3.65F, 5.0F, -4.0F, 7.0F, 9.0F, 7.0F, new CubeDeformation(0.0F)),
				PartPose.offset(4.65F, 10.0F, 3.0F));
		PartDefinition right_leg = partdefinition.addOrReplaceChild(
				"right_leg", CubeListBuilder.create().texOffs(0, 43).addBox(-2.4F, 0.0F, -3.0F, 5.0F, 4.0F, 5.0F, new CubeDeformation(0.0F))
						.texOffs(83, 82).addBox(-3.4F, 4.0F, -4.0F, 7.0F, 9.0F, 7.0F, new CubeDeformation(0.0F)),
				PartPose.offset(-4.6F, 11.0F, 3.0F));
		return LayerDefinition.create(meshdefinition, 128, 128);
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer buffer, int packedLight, int packedOverlay, float red, float green, float blue,
			float alpha) {
		head.render(poseStack, buffer, packedLight, packedOverlay);
		body.render(poseStack, buffer, packedLight, packedOverlay);
		left_hand.render(poseStack, buffer, packedLight, packedOverlay);
		right_hand.render(poseStack, buffer, packedLight, packedOverlay);
		left_leg.render(poseStack, buffer, packedLight, packedOverlay);
		right_leg.render(poseStack, buffer, packedLight, packedOverlay);
	}

	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
		this.head.yRot = netHeadYaw / (180F / (float) Math.PI);
		this.head.xRot = headPitch / (180F / (float) Math.PI);
		this.left_leg.xRot = Mth.cos(limbSwing * 1.0F) * -1.0F * limbSwingAmount;
		this.right_leg.xRot = Mth.cos(limbSwing * 1.0F) * 1.0F * limbSwingAmount;
		this.right_hand.xRot = Mth.cos(limbSwing * 0.6662F + (float) Math.PI) * limbSwingAmount;
		this.left_hand.xRot = Mth.cos(limbSwing * 0.6662F) * limbSwingAmount;
	}
}
