package net.mcreator.golemsmod.client.renderer;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.renderer.entity.layers.EyesLayer;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.EntityRendererProvider;
import net.minecraft.client.renderer.RenderType;

import net.mcreator.golemsmod.entity.LavagolemEntity;
import net.mcreator.golemsmod.client.model.Modellava_golem;

public class LavagolemRenderer extends MobRenderer<LavagolemEntity, Modellava_golem<LavagolemEntity>> {
	public LavagolemRenderer(EntityRendererProvider.Context context) {
		super(context, new Modellava_golem(context.bakeLayer(Modellava_golem.LAYER_LOCATION)), 0.5f);
		this.addLayer(new EyesLayer<LavagolemEntity, Modellava_golem<LavagolemEntity>>(this) {
			@Override
			public RenderType renderType() {
				return RenderType.eyes(new ResourceLocation("golems_mod:textures/lava_golem_texture.png"));
			}
		});
	}

	@Override
	public ResourceLocation getTextureLocation(LavagolemEntity entity) {
		return new ResourceLocation("golems_mod:textures/lava_golem_texture.png");
	}
}
